# Copyright (c) 2009 Mathias Kaerlev.
# See LICENSE for details.

# Copyright (c) 2009 Mathias Kaerlev.
# See LICENSE for details.

from Crypto.Cipher import Blowfish

import urllib

def padData(data):
    padBytes = 8 - (len(data) % 8)
    return ''.join([data, '\x00' * padBytes])

def reverseBytes(data):
    reversed = []
    for i in range(len(data)/4):
        bytes = data[i*4:i*4+4]
        reversed.append(bytes[::-1])
    return ''.join(reversed)

class MMFBlowfish(object):
    cipher = None
    
    def __init__(self, key, mode = Blowfish.MODE_ECB):
        self.cipher = Blowfish.new(key, mode)
    
    def encrypt(self, data):
        encryptData = reverseBytes(padData(data))
        encrypted = reverseBytes(self.cipher.encrypt(encryptData))
        filtered = urllib.quote(encrypted)
        return filtered
        
    def decrypt(self, data):
        decryptData = reverseBytes(urllib.unquote(data))
        return reverseBytes(self.cipher.decrypt(decryptData)).split('\x00')[0]