# Copyright (c) 2009 Mathias Kaerlev.
# See LICENSE for details.

# Copyright (c) 2009 Mathias Kaerlev.
# See LICENSE for details.

from pySndo.locals import create_number

from pySndo.network.packetloaders.common import PrefixSend

class Spawn(PrefixSend):
    x = None
    y = None
    latency = None
    def _load(self, data):
        if len(data) in (5, 6):
            self.y = int(data[:-3])
            self.x = int(data[-3:])
        elif len(data) in (7, 8, 9):
            self.latency = int(data[:-6])
            self.y = int(data[-6:-3])
            self.x = int(data[-3:])
        else:
            raise Exception('spawn data invalid: %r data')
        
    def _generate(self):
        if self.latency:
            latency = str(self.latency)
        else:
            latency = ''
        return (latency + create_number(self.y, 3) + 
                create_number(self.x, 3))

class Moving(PrefixSend):
    direction = None
    def _load(self, data):
        self.direction = int(data)
        
    def _generate(self):
        return create_number(self.direction, 2)
        
class LookDirection(PrefixSend):
    direction = None
    def _load(self, data):
        self.direction = int(data)
        
    def _generate(self):
        return create_number(self.direction, 2)

class Stopped(PrefixSend):
    x = None
    y = None
    def _load(self, data):
        self.y = int(data[:-3])
        self.x = int(data[-3:])
        
    def _generate(self):
        return create_number(self.y, 3) + create_number(self.x, 3)

class ChangeDirection(PrefixSend):
    x = None
    y = None
    direction = None
    
    def _load(self, data):
        self.y = int(data[:-5])
        self.x = int(data[-5:-2])
        self.direction = int(data[-2:])
        
    def _generate(self):
        return create_number(self.y, 3) + create_number(self.x, 3) + create_number(self.direction, 2)