# Copyright (c) 2009 Mathias Kaerlev.
# See LICENSE for details.

# Copyright (c) 2009 Mathias Kaerlev.
# See LICENSE for details.

from pySndo.network.packetloaders.common import PrefixSend

class _RemovePlayerCommon(PrefixSend):
    playerId = None
    def _load(self, data):
        self.playerId = int(data)
        
    def _generate(self):
        return str(self.playerId)

class PlayerKicked(_RemovePlayerCommon):
    pass

class PlayerBanned(_RemovePlayerCommon):
    pass

class GotBanned(PrefixSend):
    pass

class SkinChange(PrefixSend):
    def _load(self, data):
        if not int(data) == 0:
            raise Exception('skin was not null')
    
    def _generate(self):
        return str(0)

class PlayerJoined(PrefixSend):
    name = ''
    def _load(self, data):
        self.name = data
        
    def _generate(self):
        return self.name

class PlayerLeft(PrefixSend):
    pass

class PlayerKills(PrefixSend):
    kills = None
    def _load(self, data):
        self.kills = int(data)
    
    def _generate(self):
        return str(self.kills)