# Copyright (c) 2009 Mathias Kaerlev.
# See LICENSE for details.

# Copyright (c) 2009 Mathias Kaerlev.
# See LICENSE for details.

from pySndo.network.packetloaders.common import PrefixSend

from pySndo.locals import checkDefault, playerTeam

class PlayerList(PrefixSend):
    name = None
    direction = None
    moving = None
    x = None
    y = None
    team = None
    deaths = None
    kills = None
    latency = None
    typing = None
    alive = None
    
    def _load(self, data):
        splitted = data.split(',')
        
        self.direction = int(splitted.pop(0))
        
        self.moving = bool(checkDefault(int(splitted.pop(0)), 0, 9))
        
        self.x = int(splitted.pop(0))
        self.y = int(splitted.pop(0))
        
        self.alive = bool(checkDefault(int(splitted.pop(0)), 1, 0))
        
        self.latency = int(splitted.pop(0))
        self.deaths = int(splitted.pop(0))
        self.team = int(splitted.pop(0))
        self.typing = bool(int(splitted.pop(0)))
        self.kills = int(splitted.pop(0))
        
        self.name = ','.join(splitted)
            
    def getTeam(self):
        return playerTeam[self.team]
        
    def setTeam(self, teamName):
        self.team = playerTeam.index(teamName)
            
    def _generate(self):
        if self.moving:
            moving = 9
        else:
            moving = 0
        if self.alive:
            # small checks
            if len(str(self.x)) > 3 or len(str(self.y)) > 3:
                raise Exception('coordinate length exceeded: %s %s' % (self.x, self.y))
            x, y = self.x, self.y
        else:
            x, y = -20, -20
        data = ','.join([str(item) for item in
            [
            self.direction,
            moving,
            x,
            y,
            int(self.alive), self.latency, 
            self.deaths, self.team, 
            int(self.typing), self.kills,
            self.name
            ]
        ])
        return data