# Copyright (c) 2009 Mathias Kaerlev.
# See LICENSE for details.

# Copyright (c) 2009 Mathias Kaerlev.
# See LICENSE for details.

from pySndo.network.packetloaders.common import PrefixSend

from pySndo.locals import playerTeam, checkDefault

setTeam = [
    None,
    'terror',
    'police'
]

readableTeam = [
    None,
    'Terrorist',
    'Police'
]

class _TeamMixin:
    def getTeam(self):
        return readableTeam[self.team]
        
    def setTeam(self, team):
        self.team = readableTeam.index(team)

class SetTeam(PrefixSend, _TeamMixin):
    team = None
    def _load(self, data):
        self.team = setTeam.index(data)
        
    def _generate(self):
        return setTeam[self.team]

class SelfKill(PrefixSend):
    keepScore = None
    def _load(self, data):
        self.keepScore = bool(checkDefault(int(data), 0, 1))
        
    def _generate(self):
        return str(int(self.keepScore))

class TeamScore(object):
    policePoints = None
    terroristPoints = None
    def __init__(self, data = None):
        if data:
            splitted = data.split(',')
            self.policePoints = int(splitted[0])
            self.terroristPoints = int(splitted[1])

    def generate(self):
        return ','.join([str(self.policePoints), str(self.terroristPoints)])

class IncrementScore(PrefixSend, _TeamMixin):
    team = None
    def _load(self, data):
        self.team = setTeam.index(data)
        
    def _generate(self):
        return setTeam[self.team]
    